/* 
   This code accompanies the paper `Exchanging Sources Between Clean and Haskell 
   - A Double-Edged Front End for the Clean Compiler' by John van Groningen, 
   Thomas van Noort, Peter Achten, Pieter Koopman, and Rinus Plasmeijer, 
   submitted to the Haskell Symposium 2010. 
   
   Disclaimer: The implementation of the front end is work in progress. This 
   beta release is far from complete and is not fully tested.
*/
implementation module Clean3Functions

import Haskell3Functions

import StdEnv


fibsC :: [Int]
fibsC =: [1 : 1 : [x + y \\ x <- fibsC & y <- tl fibsC]]

concatMap2C :: (a -> [b]) [a] -> [b]
concatMap2C f xs = flatten (map f xs)

concatMap1C :: (a -> [b]) -> ([a] -> [b])
// concatMapC1 :: (ListF a b) -> ListF [a] b
concatMap1C f = flatten o map f

concatMap0C :: ((a -> [b]) -> [a] -> [b])
concatMap0C = \f -> flatten o map f