/* 
   This code accompanies the paper `Exchanging Sources Between Clean and Haskell 
   - A Double-Edged Front End for the Clean Compiler' by John van Groningen, 
   Thomas van Noort, Peter Achten, Pieter Koopman, and Rinus Plasmeijer, 
   submitted to the Haskell Symposium 2010. 
   
   Disclaimer: The implementation of the front end is work in progress. This 
   beta release is far from complete and is not fully tested.
*/
implementation module Clean7UniquenessTyping


mapS :: (a *s -> (b, *s)) [a] *s -> ([b], *s)
mapS f []     s = ([], s)
mapS f [x:xs] s = ([y:ys], s2)
  where (y,  s1) = f x s
        (ys, s2) = mapS f xs s1

mapS2 :: (.a .s -> (.b, .s)) [.a] .s -> ([.b], .s)
mapS2 f []     s = ([], s)
mapS2 f [x:xs] s # (y, s) = f x s
                 # (ys,s) = mapS2 f xs s
                 = ([y:ys], s)