{- 
   This code accompanies the paper `Exchanging Sources Between Clean and Haskell 
   - A Double-Edged Front End for the Clean Compiler' by John van Groningen, 
   Thomas van Noort, Peter Achten, Pieter Koopman, and Rinus Plasmeijer, 
   submitted to the Haskell Symposium 2010. 
   
   Disclaimer: The implementation of the front end is work in progress. This 
   beta release is far from complete and is not fully tested.
-}
module Haskell6TypeClasses where

import Clean6TypeClasses


class EqH a where
  eqH  :: a -> a -> Bool
  neqH :: a -> a -> Bool
  
  eqH  x y = not (neqH x y)
  neqH x y = not (eqH  x y)

instance EqC Int where
   eqC x y = x == y

{-# SPECIALIZE eqLH :: [Int]  -> [Int]  -> Bool #-}
{-# SPECIALIZE eqLH :: [Bool] -> [Bool] -> Bool #-}
eqLH :: EqH a => [a] -> [a] -> Bool
eqLH []     []     = True
eqLH []     _      = False
eqLH _      []     = False
eqLH (x:xs) (y:ys) = eqH x y && eqLH xs ys