{- 
   This code accompanies the paper `Exchanging Sources Between Clean and Haskell 
   - A Double-Edged Front End for the Clean Compiler' by John van Groningen, 
   Thomas van Noort, Peter Achten, Pieter Koopman, and Rinus Plasmeijer, 
   submitted to the Haskell Symposium 2010. 
   
   Disclaimer: The implementation of the front end is work in progress. This 
   beta release is far from complete and is not fully tested.
-}
module Haskell9Records where

import Clean9Records


data StreamH a = StreamH {elt :: a, str :: StreamH a}

updStreamH :: Int -> a -> StreamH a -> StreamH a
updStreamH i x s@(StreamH {elt = elt, str = str})
  | i < 0     = s
  | i == 0    = s {elt = x}
  | otherwise = s {str = updStreamH (i - 1) x str}

mkGenTreeH :: GenTreeC Int
mkGenTreeH = {elt = 0, kids = []}

mkStreamH :: StreamC Int
mkStreamH = {elt = 0, str = mkStreamH}

rootGenTreeH :: GenTreeC a -> a
rootGenTreeH t = t~GenTreeC~elt