implementation module CPUTime where

import StdArray

getCPUTime :: IO Integer
getCPUTime = IO getCPUTime`world

getCPUTime`world :: !*World -> (!Integer,!*World)
getCPUTime`world w = (unsafe`cpu_time,w)

// 32 bit only
unsafe`cpu_time :: Integer
unsafe`cpu_time
	# creation_time_a = createArray `2 `0
	  exit_time_a = createArray `2 `0
	  kernel_time_a = createArray `2 `0
	  user_time_a = createArray `2 `0 
	| odd (GetProcessTimes GetCurrentProcess creation_time_a exit_time_a kernel_time_a user_time_a)
		= (unsigned_int_2_array_to_integer user_time_a + unsigned_int_2_array_to_integer kernel_time_a) * 100000
		= 0

unsigned_int_2_array_to_integer :: !{#Int} -> Integer
unsigned_int_2_array_to_integer a
	# l = a~[0]
	  h = a~[1]
	| h==0
		| l>=0
			= {integer_s=l,integer_a={}}
			= {integer_s=0,integer_a={l}}
		= {integer_s=0,integer_a=a};

GetProcessTimes :: !Int -> !{#Int} -> !{#Int} -> !{#Int} -> !{#Int} -> Int
GetProcessTimes i creation_time_a exit_time_a kernel_time_a user_time_a
	= `code {
		ccall GetProcessTimes@20 "PIAAAA:I"
	}

GetCurrentProcess :: Int
GetCurrentProcess
	= `code {
		ccall GetCurrentProcess@0 "P:I"
	}

cpuTimePrecision :: Integer
cpuTimePrecision = 100000
