implementation module Char where

from PreludeInternal import readEsc
from StdMisc import abort

isAscii :: !Char -> Bool
isAscii c = c < '\x80'

isLatin1 :: !Char -> Bool
isLatin1 c = c <= '\xff'

isAlphaNum :: !Char -> Bool
isAlphaNum c
	| c<'0'
		= False
	| c<='9'
		= True
		= IsAlpha c

isControl :: !Char -> Bool
isControl c = c < ' ' || c >= '\DEL' && c <= '\x9f'

isSpace :: !Char -> Bool
isSpace c
--	= c == ' ' || c == '\t' || c == '\n' || c == '\v' || c == '\f' || c == '\r' || c=='\xA0'
	= c == ' ' || (c >= '\t' && c <= '\r') || c=='\xA0'

isOctDigit :: !Char -> Bool
isOctDigit c = c >= '0' && c <= '7'

isHexDigit :: !Char -> Bool
isHexDigit c
	| c<'0'
		= False
	| c<='9'
		= True
		# c = clear_lowercase_bit c
		= c >= 'A' && c <= 'F'

IsUpper c :== c >= 'A' && c <= 'Z'
IsDigit c :== c >= '0' && c <= '9'
IsAlpha c :== IsUpper (clear_lowercase_bit c)

digitToInt :: !Char -> Int
digitToInt c
	| IsDigit c
		= fromEnum c - fromEnum '0'
	# c = clear_lowercase_bit c
	| c >= 'A' && c <= 'F'
		= fromEnum c - 55
		= abort `"Char.digitToInt: not a digit"

intToDigit :: !Int -> Char
intToDigit i
	| i >= 0
		| i <= 9
			= toEnum (fromEnum '0' + i)
		| i <= 15
			= toEnum (87 + i)
			= intToDigit_error
		= intToDigit_error

intToDigit_error
	= abort `"Char.intToDigit: not a digit"

readLitChar :: !String -> [(Char,String)]
readLitChar ('\\':s) = readEsc s
readLitChar (c:s) = [(c,s)]

clear_lowercase_bit :: !Char -> Char
clear_lowercase_bit c = `code inline {
		pushI 223
		and%
	}
