definition module Complex where

from PreludeTypes import ::Integer,::Rational,::String,
							class Eq,class Show,class Num,class Fractional,class Floating,class Read
from PreludeTypes import qualified class RealFloat,::Ratio

data {- (PreludeTypes.RealFloat a) => -}
	Complex a = (:+) infix 6 !a !a

instance (Eq a) => Eq (Complex a) where
	(==) :: (Eq a) => !(Complex a) -> !(Complex a) -> Bool special a=Double;a=Float
	(/=) :: (Eq a) => !(Complex a) -> !(Complex a) -> Bool special a=Double;a=Float

instance (Show a) => Show (Complex a) where
	show :: (Show a) => !(Complex a) -> [Char] special a=Double;a=Float
	showsPrec :: (Show a) => !Int -> !(Complex a) -> ([Char]->[Char]) special a=Double;a=Float

instance (Read a) => Read (Complex a) where
	readsPrec :: (Read a) => !Int -> ![Char] -> [(Complex a,[Char])] special a=Double;a=Float

--realPart :: (PreludeTypes.RealFloat a) => Complex a -> a
realPart c :== let (x:+y) = c in x
--imagPart :: (PreludeTypes.RealFloat a) => Complex a -> a
imagPart c :== let (x:+y) = c in y

conjugate :: (PreludeTypes.RealFloat a) => !(Complex a) -> Complex a special a=Double;a=Float

mkPolar :: (PreludeTypes.RealFloat a) => a -> a -> Complex a special a=Double:==mkPolar`Double;a=Float:==mkPolar`Float
mkPolar`Double :: !Double -> !Double -> Complex Double
mkPolar`Float :: !Float -> !Float -> Complex Float

cis :: (PreludeTypes.RealFloat a) => a -> Complex a special a=Double:==cis`Double;a=Float:==cis`Float
cis`Double :: !Double -> Complex Double
cis`Float :: !Float -> Complex Float

polar :: (PreludeTypes.RealFloat a) => Complex a -> (a,a) special a=Double:==polar`Double;a=Float:==polar`Float
polar`Double :: Complex Double -> (Double,Double)
polar`Float :: Complex Float -> (Float,Float)

magnitude :: (PreludeTypes.RealFloat a) => !Complex a -> a special a=Double:==magnitude`Double;a=Float:==magnitude`Float
magnitude`Double :: !Complex Double -> Double
magnitude`Float :: !Complex Float -> Float

phase :: (PreludeTypes.RealFloat a) => !Complex a -> a special a=Double;a=Float

instance (PreludeTypes.RealFloat a) => Num (Complex a) where
	(+) :: (PreludeTypes.RealFloat a) => (Complex a) -> !(Complex a) -> Complex a special a=Double;a=Float
	(-) :: (PreludeTypes.RealFloat a) => (Complex a) -> !(Complex a) -> Complex a special a=Double;a=Float
	(*) :: (PreludeTypes.RealFloat a) => (Complex a) -> !(Complex a) -> Complex a special a=Double;a=Float
	negate :: (PreludeTypes.RealFloat a) => !(Complex a) -> Complex a special a=Double;a=Float
	abs :: (PreludeTypes.RealFloat a) => !(Complex a) -> Complex a special a=Double:==abs`ComplexDouble;a=Float:==abs`ComplexFloat
	signum :: (PreludeTypes.RealFloat a) => !(Complex a) -> Complex a special a=Double:==signum`ComplexDouble;a=Float:==signum`ComplexFloat
	fromInteger :: (PreludeTypes.RealFloat a) => !Integer -> Complex a special a=Double;a=Float

abs`ComplexDouble :: !(Complex Double) -> Complex Double
abs`ComplexFloat :: !(Complex Float) -> Complex Float
signum`ComplexDouble :: !(Complex Double) -> Complex Double
signum`ComplexFloat :: !(Complex Float) -> Complex Float

instance (PreludeTypes.RealFloat a) => Fractional (Complex a) where
	(/) :: (PreludeTypes.RealFloat a) => !(Complex a) -> !(Complex a) -> Complex a special a=Double;a=Float
	fromRational :: (PreludeTypes.RealFloat a) => !Rational -> Complex a	special a=Double;a=Float

instance (PreludeTypes.RealFloat a) => Floating (Complex a) where
	pi :: (PreludeTypes.RealFloat a) => Complex a special a=Double;a=Float
	exp :: (PreludeTypes.RealFloat a) => !(Complex a) -> Complex a special a=Double;a=Float
	log :: (PreludeTypes.RealFloat a) => !(Complex a) -> Complex a special a=Double:==log`ComplexDouble;a=Float:==log`ComplexFloat
	sqrt :: (PreludeTypes.RealFloat a) => !(Complex a) -> Complex a special a=Double:==sqrt`ComplexDouble;a=Float:==sqrt`ComplexFloat
	sin :: (PreludeTypes.RealFloat a) => !(Complex a) -> Complex a special a=Double:==sin`ComplexDouble;a=Float:==sin`ComplexFloat
	cos :: (PreludeTypes.RealFloat a) => !(Complex a) -> Complex a special a=Double:==cos`ComplexDouble;a=Float:==cos`ComplexFloat
	tan :: (PreludeTypes.RealFloat a) => !(Complex a) -> Complex a special a=Double:==tan`ComplexDouble;a=Float:==tan`ComplexFloat
	sinh :: (PreludeTypes.RealFloat a) => !(Complex a) -> Complex a special a=Double:==sinh`ComplexDouble;a=Float:==sinh`ComplexFloat
	cosh :: (PreludeTypes.RealFloat a) => !(Complex a) -> Complex a special a=Double:==cosh`ComplexDouble;a=Float:==cosh`ComplexFloat
	tanh :: (PreludeTypes.RealFloat a) => !(Complex a) -> Complex a special a=Double:==tanh`ComplexDouble;a=Float:==tanh`ComplexFloat
	asin :: (PreludeTypes.RealFloat a) => !(Complex a) -> Complex a special a=Double:==asin`ComplexDouble;a=Float:==asin`ComplexFloat
	acos :: (PreludeTypes.RealFloat a) => !(Complex a) -> Complex a special a=Double:==acos`ComplexDouble;a=Float:==acos`ComplexFloat
	atan :: (PreludeTypes.RealFloat a) => !(Complex a) -> Complex a special a=Double:==atan`ComplexDouble;a=Float:==atan`ComplexFloat
	asinh :: (PreludeTypes.RealFloat a) => !(Complex a) -> Complex a special a=Double:==asinh`ComplexDouble;a=Float:==asinh`ComplexFloat
	acosh :: (PreludeTypes.RealFloat a) => !(Complex a) -> Complex a special a=Double:==acosh`ComplexDouble;a=Float:==acosh`ComplexFloat
	atanh :: (PreludeTypes.RealFloat a) => !(Complex a) -> Complex a special a=Double:==atanh`ComplexDouble;a=Float:==atanh`ComplexFloat

log`ComplexDouble :: !(Complex Double) -> Complex Double
log`ComplexFloat :: !(Complex Float) -> Complex Float
sqrt`ComplexDouble :: !(Complex Double) -> Complex Double
sqrt`ComplexFloat :: !(Complex Float) -> Complex Float
sin`ComplexDouble :: !(Complex Double) -> Complex Double
sin`ComplexFloat :: !(Complex Float) -> Complex Float
cos`ComplexDouble :: !(Complex Double) -> Complex Double
cos`ComplexFloat :: !(Complex Float) -> Complex Float
tan`ComplexDouble :: !(Complex Double) -> Complex Double
tan`ComplexFloat :: !(Complex Float) -> Complex Float
sinh`ComplexDouble :: !(Complex Double) -> Complex Double
sinh`ComplexFloat :: !(Complex Float) -> Complex Float
cosh`ComplexDouble :: !(Complex Double) -> Complex Double
cosh`ComplexFloat :: !(Complex Float) -> Complex Float
tanh`ComplexDouble :: !(Complex Double) -> Complex Double
tanh`ComplexFloat :: !(Complex Float) -> Complex Float
asin`ComplexDouble :: !(Complex Double) -> Complex Double
asin`ComplexFloat :: !(Complex Float) -> Complex Float
acos`ComplexDouble :: !(Complex Double) -> Complex Double
acos`ComplexFloat :: !(Complex Float) -> Complex Float
atan`ComplexDouble :: !(Complex Double) -> Complex Double
atan`ComplexFloat :: !(Complex Float) -> Complex Float
asinh`ComplexDouble :: !(Complex Double) -> Complex Double
asinh`ComplexFloat :: !(Complex Float) -> Complex Float
acosh`ComplexDouble :: !(Complex Double) -> Complex Double
acosh`ComplexFloat :: !(Complex Float) -> Complex Float
atanh`ComplexDouble :: !(Complex Double) -> Complex Double
atanh`ComplexFloat :: !(Complex Float) -> Complex Float
