definition module Control.Monad where

from Prelude import mapM_,class Monad(return,>>=)
from PreludeTypes import ::()(..)

liftM2  :: (a1 -> a2 -> r) -> m a1 -> m a2 -> m r | Monad m
liftM3  :: (a1 -> a2 -> a3 -> r) -> m a1 -> m a2 -> m a3 -> m r | Monad m
liftM4  :: (a1 -> a2 -> a3 -> a4 -> r) -> m a1 -> m a2 -> m a3 -> m a4 -> m r | Monad m
zipWithM_ :: (a -> b -> m c) -> [a] -> [b] -> m () | Monad m

--foldM :: (Monad m) => (a -> b -> m a) -> a -> [b] -> m a
foldM f r l :== foldM r l
 where
	foldM r (a:as) = f r a >>= \fra -> foldM fra as
	foldM r [] =  return r

replicateM :: (Monad m) => Int -> m a -> m [a]

--when :: (Monad m) => Bool -> m () -> m ()
when p s :== if p then s else return ()

--unless :: (Monad m) => Bool -> m () -> m ()
unless p s :== if p then return () else s
