implementation module Control.Monad.ST where

newtype ST s a = ST (STRep s a)

type STRep s a = s -> ( s, a )

instance Functor (ST s) where
    fmap f (ST m) = ST $ \ s ->
      case (m s) of { ( new_s, r ) ->
      	( new_s, f r ) }

instance Monad (ST s) where
    return x = ST (\ s -> ( s, x ))
    m >> k   = m >>= \ _ -> k

    (ST m) >>= k
      = ST (\ s ->
        case (m s) of { (new_s, r) ->
        case (k r) of { ST k2 ->
	    (k2 new_s) }})

runST :: !(A. s: ST s a) -> a
//runST st = runSTRep (case st of { ST st_rep -> st_rep })
runST (ST st_rep) = runSTRep st_rep

runSTRep :: (A. s: STRep s a) -> a
runSTRep st_rep = case st_rep realWorld of
                        (_, r) -> r

realWorld :: *World
realWorld = `code {
	fillI 65536 0
}
