implementation module Data.Array.Base where

import Data.Array.MArray
from StdMisc import abort

//from StdDebug import trace_tn
//from StdString import class toString

readArray :: (MArray a e m, Ix i) => a i e -> i -> m e
readArray marr i = abort `"readArray"
/*
do
  (l,u) <- getBounds marr
  n <- getNumElements marr
  unsafeRead marr (safeIndex (l,u) n i)
*/
readArray`Int_STArray_ST :: (STArray s1 Int e) -> Int -> ST s2 e
readArray`Int_STArray_ST a i
	= ST (readArray`Int_STArray_ST_s a i)

readArray`Int_STArray_ST_s :: !(STArray s1 Int e) -> !Int -> !s2 -> (!s2,e)
readArray`Int_STArray_ST_s (STArray l h a) i s
//	| trace_tn `"readArray`Int_STArray_ST_s"

	#! e = a~[i-l]
	= (s,e)

writeArray :: (MArray a e m, Ix i) => a i e -> i -> e -> m ()
writeArray marr i e = abort `"writeArray"
/*
do
  (l,u) <- getBounds marr
  n <- getNumElements marr
  unsafeWrite marr (safeIndex (l,u) n i) e
*/

writeArray`Int_STArray_ST :: (STArray s1 Int e) -> Int -> e -> ST s2 ()
writeArray`Int_STArray_ST a i e
	= ST (writeArray`Int_STArray_ST_s a i e)

writeArray`Int_STArray_ST_s :: !(STArray s1 Int e) -> !Int -> e -> !s2 -> (!s2,!())
writeArray`Int_STArray_ST_s (STArray l h a) i e s
//	| trace_tn `"writeArray`Int_STArray_ST_s"

--	# a = updateLazyArray_ a (i-l) e
--	= (seq a s,())

	= (updateLazyArray_s_ a (i-l) e s,())

updateLazyArray_ :: !{.e} -> !Int -> .e -> {.e}
updateLazyArray_ arr index el
	=`code {	
		update _ 1 0
	}

updateLazyArray_s_ :: !{.e} -> !Int -> .e -> !.s -> .s
updateLazyArray_s_ arr index el s
	=`code inline {
		update _ 1 0
		.keep 0 1
		pop_a 1
	}
