definition module Data.Word

from PreludeTypes import qualified
	class Eq,class Ord,class Num,class Integral,class Enum,class Show,class Real,
	::Integer,::Ordering,::Rational

:: Word8 (:==Int)
:: Word16(:==Int)
:: Word32(:==Int)

instance PreludeTypes.Eq Word8 where
	(==) :: !Word8 !Word8 -> Bool
	(/=) :: !Word8 !Word8 -> Bool

instance PreludeTypes.Eq Word16 where
	(==) :: !Word16 !Word16 -> Bool
	(/=) :: !Word16 !Word16 -> Bool

instance PreludeTypes.Eq Word32 where
	(==) :: !Word32 !Word32 -> Bool
	(/=) :: !Word32 !Word32 -> Bool

instance PreludeTypes.Ord Word8 where
	(<)  :: !Word8 !Word8 -> Bool
	(<=) :: !Word8 !Word8 -> Bool
	(>=) :: !Word8 !Word8 -> Bool
	(>)  :: !Word8 !Word8 -> Bool
	compare :: !Word8 !Word8 -> PreludeTypes.Ordering
	min :: !Word8 !Word8 -> Word8
	max :: !Word8 !Word8 -> Word8

instance PreludeTypes.Ord Word32 where
	(<)  :: !Word32 !Word32 -> Bool
	(<=) :: !Word32 !Word32 -> Bool
	(>=) :: !Word32 !Word32 -> Bool
	(>)  :: !Word32 !Word32 -> Bool
	compare :: !Word32 !Word32 -> PreludeTypes.Ordering
	min :: !Word32 !Word32 -> Word32
	max :: !Word32 !Word32 -> Word32

instance PreludeTypes.Num Word8 where
	(+) :: !Word8 !Word8 -> Word8
	(-) :: !Word8 !Word8 -> Word8
	(*) :: !Word8 !Word8 -> Word8
	abs :: !Word8 -> Word8
	signum :: !Word8 -> Word8
	negate :: !Word8 -> Word8
	fromInteger :: !PreludeTypes.Integer -> Word8

instance PreludeTypes.Num Word16 where
	(+) :: !Word16 !Word16 -> Word16
	(-) :: !Word16 !Word16 -> Word16
	(*) :: !Word16 !Word16 -> Word16
	abs :: !Word16 -> Word16
	signum :: !Word16 -> Word16
	negate :: !Word16 -> Word16
	fromInteger :: !PreludeTypes.Integer -> Word16

instance PreludeTypes.Num Word32 where
	(+) :: !Word32 !Word32 -> Word32
	(-) :: !Word32 !Word32 -> Word32
	(*) :: !Word32 !Word32 -> Word32
	abs :: !Word32 -> Word32
	signum :: !Word32 -> Word32
	negate :: !Word32 -> Word32
	fromInteger :: !PreludeTypes.Integer -> Word32

instance PreludeTypes.Integral Word8 where
	toInteger :: !Word8 -> PreludeTypes.Integer
	quot :: !Word8 !Word8 -> Word8
	rem :: !Word8 !Word8 -> Word8
	div :: !Word8 !Word8 -> Word8
	mod :: !Word8 !Word8 -> Word8
	quotRem :: !Word8 !Word8 -> (!Word8,!Word8)
	divMod :: !Word8 !Word8 -> (!Word8,!Word8)

instance PreludeTypes.Integral Word32 where
	toInteger :: !Word32 -> PreludeTypes.Integer
	quot :: !Word32 !Word32 -> Word32
	rem :: !Word32 !Word32 -> Word32
	div :: !Word32 !Word32 -> Word32
	mod :: !Word32 !Word32 -> Word32
	quotRem :: !Word32 !Word32 -> (!Word32,!Word32)
	divMod :: !Word32 !Word32 -> (!Word32,!Word32)

instance PreludeTypes.Enum Word8 where
	toEnum :: !Int -> Word8
	fromEnum :: !Word8 -> Int

instance PreludeTypes.Enum Word32 where
	toEnum :: !Int -> Word32
	fromEnum :: !Word32 -> Int

instance PreludeTypes.Show Word8 where
	show :: !Word8 -> [Char]

instance PreludeTypes.Show Word16 where
	show :: !Word16 -> [Char]

instance PreludeTypes.Show Word32 where
	show :: !Word32 -> [Char]

instance PreludeTypes.Real Word8 where
	toRational :: !Word8 -> PreludeTypes.Rational

instance PreludeTypes.Real Word32 where
	toRational :: !Word32 -> PreludeTypes.Rational
