implementation module Maybe where

import Prelude (Maybe(..))
from StdMisc import abort

isJust :: !Maybe a -> Bool
isJust (Just _) = True
isJust _ = False

isNothing :: !Maybe a -> Bool
isNothing Nothing = True
isNothing _ = False

fromJust :: !Maybe a -> a
fromJust (Just a) = a
fromJust _ = abort `"Maybe.fromJust: Nothing"

fromMaybe :: a -> !(Maybe a) -> a
fromMaybe d Nothing = d
fromMaybe d (Just a) = a

maybeToList :: !(Maybe a) -> [a]
maybeToList Nothing = []
maybeToList (Just a) = [a]

listToMaybe :: ![a] -> Maybe a
listToMaybe [] = Nothing
listToMaybe (a:_) = Just a

catMaybes :: ![Maybe a] -> [a]
catMaybes ms = [m | Just m <- ms]

mapMaybe :: (a -> Maybe b) -> ([a] -> [b])
mapMaybe f = mapMaybe
	where
		mapMaybe (e:l)
			= case f e of
				Just m
					-> m : mapMaybe l
				_
					-> mapMaybe l
		mapMaybe []
			= []
