definition module Monad where

from Prelude import class Monad (return),:: ()(()),::Maybe,::IO

class (Monad m) => MonadPlus m where
	mzero :: m a
	mplus :: m a -> m a -> m a

instance MonadPlus Maybe where
	mplus :: !(Maybe a) -> Maybe a -> Maybe a

instance MonadPlus [] where
	mplus :: ![a] -> [a] -> [a]

msum :: MonadPlus m => ![m a] -> m a
join :: (Monad m) => m (m a) -> m a
--when :: (Monad m) => Bool -> m () -> m ()
when p s :== if p then s else return ()
--unless :: (Monad m) => Bool -> m () -> m ()
unless p s :== if p then return () else s
ap :: (Monad m) => m (a -> b) -> m a -> m b special m=IO
//guard :: MonadPlus m => Bool -> m ()
guard p :== if p then return () else mzero
mapAndUnzipM :: (Monad m) => (a -> m (b,c)) -> [a] -> m ([b], [c]) special m=IO
zipWithM :: (Monad m) => (a -> b -> m c) -> [a] -> [b] -> m [c] special m=IO
zipWithM_ :: (Monad m) => (a -> b -> m c) -> [a] -> [b] -> m () special m=IO
foldM :: (Monad m) => (a -> b -> m a) -> a -> ![b] -> m a special m=IO
liftM2  :: (Monad m) => (a1 -> a2 -> r) -> m a1 -> m a2 -> m r special m=IO
liftM3  :: (Monad m) => (a1 -> a2 -> a3 -> r) -> m a1 -> m a2 -> m a3 -> m r special m=IO
liftM4  :: (Monad m) => (a1 -> a2 -> a3 -> a4 -> r) -> m a1 -> m a2 -> m a3 -> m a4 -> m r special m=IO
liftM5  :: (Monad m) => (a1 -> a2 -> a3 -> a4 -> a5 -> r) -> m a1 -> m a2 -> m a3 -> m a4 -> m a5 -> m r special m=IO
