implementation module PackedString where

import Prelude
from _SystemArray import class Array (..),instance Array {#} Char;
from StdInt import qualified instance + Int,instance one Int

type PackedString=`String

packString :: !String -> PackedString
packString s = {c ;; c<-s}

unpackPS :: !PackedString -> String
unpackPS s = [c ;; c<-:s]

instance Eq PackedString
	where
	(==) :: !PackedString -> !PackedString -> Bool
	(==) s1 s2 = `code inline {
				.d 2 0
					jsr eqAC
				.o 0 1 b
			}

	(/=) :: !PackedString -> !PackedString -> Bool
	(/=) s1 s2 = `code inline {
				.d 2 0
					jsr eqAC
				.o 0 1 b
					notB
			}

instance Ord PackedString
	where
	(<) :: !PackedString -> !PackedString -> Bool
 	(<) a b = `code inline {
		.d 2 0
			jsr cmpAC
		.o 0 1 i
			pushI 0
			gtI
	}

	(>) :: !PackedString -> !PackedString -> Bool
 	(>) a b = `code inline {
		.d 2 0
			jsr cmpAC
		.o 0 1 i
			pushI 0
			ltI
	}

	(<=) :: !PackedString -> !PackedString -> Bool
 	(<=) a b = `code inline {
		.d 2 0
			jsr cmpAC
		.o 0 1 i
			pushI 0
			ltI
			notB
	}

	(>=) :: !PackedString -> !PackedString -> Bool
 	(>=) a b = `code inline {
		.d 2 0
			jsr cmpAC
		.o 0 1 i
			pushI 0
			gtI
			notB
	}

	compare a b
		=	let c=compare_string a b in
			if c==0 then EQ else if c<0 then LT else GT

	min a b = let c=compare_string a b in if c<=0 then a else b

	max a b = let c=compare_string a b in if c>=0 then a else b

compare_string :: !PackedString -> !PackedString -> Int
compare_string = `code inline {
		.d 2 0
			jsr cmpAC
		.o 0 1 i
	}

instance Show PackedString where
	showsPrec _ s = string_to_char_list_append s

//also defined in Prelude

string_to_char_list_append s t = string_to_char_list_append 0 s t
where
	string_to_char_list_append i s t
		| i<size s
			#! c=s~[i]
			= c:string_to_char_list_append (i+1) s t
			= t
