implementation module PreludeInline where

import PreludeTypes

from StdOverloaded import class toInt (..),class toReal(..)
from StdInt import instance toInt Double,bitxor,bitor,IF_INT_64_OR_32
from StdReal import entier,instance toReal Int
from StdFloat import class toFloat(..),instance toFloat Double,instance toReal Float
from StdMisc import abort

import qualified PreludeInteger
import qualified PreludeFloat

shiftr :: !Int -> !Int -> Int;
shiftr a b = `code inline {
	shiftr%
}

ushiftr :: !Int -> !Int -> Int;
ushiftr a b = `code inline {
	shiftrU
}

negate_int :: !Int -> Int
negate_int a = `code {
		negI
	}

instance Eq Int where
	(==) :: !Int -> !Int -> Bool
	a == b = `code inline {
				eqI
		}

	(/=) :: !Int -> !Int -> Bool
	a /= b = `code inline {
				eqI
				notB
		}

instance Eq Char where
	(==) :: !Char -> !Char -> Bool
	a == b = `code inline {
				eqC
		}

	(/=) :: !Char -> !Char -> Bool
	a /= b = `code inline {
				eqC
				notB
		}

instance Eq Double where
	(==) :: !Double -> !Double -> Bool
	a == b = `code inline {
				eqR
		}

	(/=) :: !Double -> !Double -> Bool
	a /= b = `code inline {
				eqR
				notB
		}

instance Eq Float where
	(==) :: !Float -> !Float -> Bool
	a == b = `code inline {
				eqRs
		}

	(/=) :: !Float -> !Float -> Bool
	a /= b = `code inline {
				eqRs
				notB
		}

instance Eq Bool where
	(==) :: !Bool -> !Bool -> Bool
	a == b = `code inline {
				eqB
		}

	(/=) :: !Bool -> !Bool -> Bool
	a /= b = `code inline {
				eqB
				notB
		}

instance Ord Int where
	compare :: !Int -> !Int -> Ordering
	compare a b
		= if a==b
		  then EQ
		  else  if a<b
				then LT
				else GT

	(<=) infix 4 :: !Int -> !Int -> Bool
	x <= y = `code inline {
				gtI
				notB
			}

	(<) infix  4 :: !Int -> !Int -> Bool
	x < y  = `code inline {
				ltI
			}

	(>=) infix 4 :: !Int -> !Int -> Bool
	x >= y = `code inline {
				ltI
				notB
			}

	(>) infix  4 :: !Int -> !Int -> Bool
	x > y  = `code inline {
				gtI
			} 

	min :: !Int -> !Int -> Int
	min x y  = `code inline {
				.newlocallabel _INT_min
				push_b 1
				push_b 1
				ltI
				jmp_false _INT_min
				update_b 0 1
			:_INT_min
				pop_b 1
			}

	max :: !Int -> !Int -> Int
	max x y = `code inline {
				.newlocallabel _INT_max
				push_b 1
				push_b 1
				gtI
				jmp_false _INT_max
				update_b 0 1
			:_INT_max
				pop_b 1
			}

instance Ord Char where
	compare :: !Char -> !Char -> Ordering
	compare a b
		= if a==b
		  then EQ
		  else  if a<b
				then LT
				else GT

	(<=) infix 4 :: !Char -> !Char -> Bool
	x <= y = `code inline {
				gtC
				notB
			}

	(<) infix  4 :: !Char -> !Char -> Bool
	x < y  = `code inline {
				ltC
			}

	(>=) infix 4 :: !Char -> !Char -> Bool
	x >= y = `code inline {
				ltC
				notB
			}

	(>) infix  4 :: !Char -> !Char -> Bool
	x > y  = `code inline {
				gtC
			} 

	min :: !Char -> !Char -> Char
	min x y  = `code inline {
				.newlocallabel _CHAR_min
				push_b 1
				push_b 1
				ltC
				jmp_false _CHAR_min
				update_b 0 1
			:_CHAR_min
				pop_b 1
			}

	max :: !Char -> !Char -> Char
	max x y = `code inline {
				.newlocallabel _CHAR_max
				push_b 1
				push_b 1
				gtC
				jmp_false _CHAR_max
				update_b 0 1
			:_CHAR_max
				pop_b 1
			}

instance Ord Double where
	compare :: !Double -> !Double -> Ordering
	compare a b
		= if a==b
		  then EQ
		  else  if a<b
				then LT
				else GT

	(<=) infix 4 :: !Double -> !Double -> Bool
	x <= y = `code inline {
				gtR
				notB
			}

	(<) infix  4 :: !Double -> !Double -> Bool
	x < y  = `code inline {
				ltR
			}

	(>=) infix 4 :: !Double -> !Double -> Bool
	x >= y = `code inline {
				ltR
				notB
			}

	(>) infix  4 :: !Double -> !Double -> Bool
	x > y  = `code inline {
				gtR
			} 

	min :: !Double -> !Double -> Double
	min x y  = `code inline {
				.newlocallabel _REAL_min
				push_b 3
				push_b 3
				push_b 3
				push_b 3
				ltR
				jmp_false _REAL_min
				update_b 1 3
				update_b 0 2
			:_REAL_min
				pop_b 2
			}

	max :: !Double -> !Double -> Double
	max x y = `code inline {
				.newlocallabel _REAL_max
				push_b 3
				push_b 3
				push_b 3
				push_b 3
				gtR
				jmp_false _REAL_max
				update_b 1 3
				update_b 0 2
			:_REAL_max
				pop_b 2
			}

instance Ord Float where
	compare :: !Float -> !Float -> Ordering
	compare a b
		= if a==b
		  then EQ
		  else  if a<b
				then LT
				else GT

	(<=) infix 4 :: !Float -> !Float -> Bool
	x <= y = `code inline {
				gtRs
				notB
			}

	(<) infix  4 :: !Float -> !Float -> Bool
	x < y  = `code inline {
				ltRs
			}

	(>=) infix 4 :: !Float -> !Float -> Bool
	x >= y = `code inline {
				ltRs
				notB
			}

	(>) infix  4 :: !Float -> !Float -> Bool
	x > y  = `code inline {
				gtRs
			} 

	min :: !Float -> !Float -> Float
	min x y  = `code inline {
				.newlocallabel _FLOAT_min
				push_b 1
				push_b 1
				ltRs
				jmp_false _FLOAT_min
				update_b 0 1
			:_FLOAT_min
				pop_b 1
			}

	max :: !Float -> !Float -> Float
	max x y = `code inline {
				.newlocallabel _FLOAT_max
				push_b 1
				push_b 1
				gtRs
				jmp_false _FLOAT_max
				update_b 0 1
			:_FLOAT_max
				pop_b 1
			}

instance Enum Char where
	toEnum :: !Int -> Char
	toEnum i = `code inline {
				ItoC
				}

	fromEnum :: !Char -> Int
	fromEnum c = `code inline {
				CtoI
				}

instance Integral Int where
	toInteger :: !Int -> Integer
	toInteger i = `code inline {
		pushI 0
		create_array_ INT 0 1
	}

	quot :: !Int -> !Int -> Int
	quot a b = `code inline {
		divI
	}

	rem :: !Int -> !Int -> Int
	rem a b = `code inline {
		remI
	}

	div :: !Int -> !Int -> Int
	div a b = `code inline {
		floordivI
	}

	mod :: !Int -> !Int -> Int
	mod a b = `code inline {
		modI
	}

	quotRem :: !Int -> !Int -> (!Int,!Int)
	quotRem a b = `code inline {
		push_b 1
		push_b 1
		divI
		push_b 2
		push_b 1
		mulI
		push_b 2
		subI
		update_b 0 3
		update_b 1 2
		pop_b 2
	}

	divMod :: !Int -> !Int -> (!Int,!Int)
	divMod a b = `code inline {
		push_b 1
		push_b 1
		floordivI
		push_b 2
		push_b 1
		mulI
		push_b 2
		subI
		update_b 0 3
		update_b 1 2
		pop_b 2
	}

instance Num Int
	where
		(+) :: !Int -> !Int -> Int
		a + b
			= `code inline {
				addI
			}
		(-) :: !Int -> !Int -> Int
		a - b
			= `code inline {
				subI
			}
		(*) :: !Int -> !Int -> Int
		a * b
			= `code inline {
				mulI
			}
		abs :: !Int -> Int
		abs a
		 	| a<0
		 		= negate a
		 		= a
		signum :: !Int -> Int
		signum a
			= (shiftr a (IF_INT_64_OR_32 63 31)) bitor (ushiftr (negate_int a) (IF_INT_64_OR_32 63 31))
		negate :: !Int -> Int
		negate a
			= `code inline {
				negI
			}
		fromInteger :: !Integer -> Int
		fromInteger {integer_s,integer_a}
			| size integer_a==0
				= integer_s;
				= (integer_a~[0] bitxor integer_s) - integer_s;

instance Num Double where
	(+) :: !Double -> !Double -> Double
	a + b
		= `code inline {
			addR
		}
	(-) :: !Double -> !Double -> Double
	a - b
		= `code inline {
			subR
		}
	(*) :: !Double -> !Double -> Double
	a * b
		= `code inline {
			mulR
		}
	abs :: !Double -> Double
	abs a
		= `code inline {
			absR
		}
	signum :: !Double -> Double
	signum r
		| r>0
			= 1.0
		| r==0
			= 0.0
			= -1.0
	negate :: !Double -> Double
	negate a
		= `code inline {
			negR
		}
	fromInteger :: !Integer -> Double
	fromInteger {integer_s,integer_a}
		| size integer_a==0
			= toReal integer_s;
			= integer_a_to_double integer_s integer_a;

instance Num Float where
	(+) :: !Float -> !Float -> Float
	a + b
		= `code inline {
			addRs
		}
	(-) :: !Float -> !Float -> Float
	a - b
		= `code inline {
			subRs
		}
	(*) :: !Float -> !Float -> Float
	a * b
		= `code inline {
			mulRs
		}
	abs :: !Float -> Float
	abs a
		= `code inline {
			absRs
		}
	signum :: !Float -> Float
	signum f
		| f>0
			= `1.0f
		| f==0
			= `0.0f
			= `-1.0f
	negate :: !Float -> Float
	negate a
		= `code inline {
			negRs
		}
	fromInteger :: !Integer -> Float
	fromInteger {integer_s,integer_a}
		| size integer_a==0
			= toFloat (toReal integer_s);
			= toFloat (integer_a_to_double integer_s integer_a);

desc0_number' :: !a -> Int;
desc0_number' _ = `code inline {
	pushD_a 0
	pop_a 1
	get_desc0_number
}

get_desc' :: !a -> Int;
get_desc' _ = `code inline {
	pushD_a 0
	pop_a 1
}

get_desc0_number' :: !Int -> Int;
get_desc0_number' _ = `code inline {
	get_desc0_number
}

equal_constructor :: !a -> !a -> Bool;
equal_constructor _ _ = `code inline {
		pushD_a 1
		pushD_a 0
		pop_a 2
		eqI
};

less_constructor :: !a -> !a -> Bool;
less_constructor _ _ = `code inline {
		pushD_a 1
		pushD_a 0
		pop_a 2
		ltI
};

less_or_equal_constructor :: !a -> !a -> Bool;
less_or_equal_constructor _ _ = `code inline {
		pushD_a 1
		pushD_a 0
		pop_a 2
		gtI
		notB
};

greater_constructor :: !a -> !a -> Bool;
greater_constructor _ _ = `code inline {
		pushD_a 1
		pushD_a 0
		pop_a 2
		gtI
};

greater_or_equal_constructor :: !a -> !a -> Bool;
greater_or_equal_constructor _ _ = `code inline {
		pushD_a 1
		pushD_a 0
		pop_a 2
		ltI
		notB
};

instance Eq Ordering where
	(==) :: !Ordering -> !Ordering -> Bool
	(==) a b = `code inline {
		eqI
	}
/*
	(==) a b = `code inline {
		pushD_a 1
		pushD_a 0
		pop_a 2
		eqI
	}
*/
	(/=) :: !Ordering -> !Ordering -> Bool
	(/=) a b = `code inline {
		eqI
		notB
	}
/*
	(/=) a b = `code inline {
		pushD_a 1
		pushD_a 0
		pop_a 2
		eqI
		notB
	}
*/

instance Fractional Double where
	(/) :: !Double -> !Double -> Double
	a / b
		= `code inline {
			divR
		}
	recip :: !Double -> Double
	recip a
		= `code inline {
			pushR 1.0
			divR
		}
	fromRational :: !Rational -> Double
	fromRational r
		= rational_to_double r

instance Fractional Float where
	(/) :: !Float -> !Float -> Float
	a / b
		= `code inline {
			divRs
		}
	recip :: !Float -> Float
	recip a
		= `code inline {
			pushRs 1.0
			divRs
		}
	fromRational :: !Rational -> Float
	fromRational r
		= toFloat (rational_to_double r)

instance Floating Double where
	sqrt :: !Double -> Double
	sqrt a
		= `code inline {
			sqrtR
		}
	log :: !Double -> Double
	log a
		= `code inline {
			lnR
		}
	exp :: !Double -> Double
	exp a
		= `code inline {
			expR
		}
	sin :: !Double -> Double
	sin a
		= `code inline {
			sinR
		}
	cos :: !Double -> Double
	cos a
		= `code inline {
			cosR
		}
	tan :: !Double -> Double
	tan a
		= `code inline {
			tanR
		}
	atan :: !Double -> Double
	atan a
		= `code inline {
			atanR
		}
	asin :: !Double -> Double
	asin a
		= `code inline {
			asinR
		}
	acos :: !Double -> Double
	acos a
		= `code inline {
			acosR
		}
	pi :: Double
	pi
		= `code inline {
			pushR 3.141592653589793238
		}
	sinh :: !Double -> Double
	sinh x
		| (abs x)<=3.0E-6
			= x+x*x*x/6.0
			# exp_x = exp x
			  exp_xd = exp_x - 1.0
			= 0.5 * (exp_xd + exp_xd / exp_x)
	cosh :: !Double -> Double
	cosh x
		# exp_x = exp x
		= 0.5*exp_x + 0.5/exp_x
	tanh :: !Double -> Double
	tanh x
		| x>=0.0
			| x<=1.0
				| x<=3.0E-6
					= x-x*x*x/3.0
					# recip_sq_exp_x = exp (-2.0*x)
					= (1.0 - recip_sq_exp_x) / (1.0 + recip_sq_exp_x)
				| x<=23.0
					= 1.0 - 2.0 / (1.0 + exp (2.0*x))
					= 1.0
			| x>= -1.0
				| x>= -3.0E-6
					= x-x*x*x/3.0
					# recip_sq_exp_x = exp (2.0*x)
					= (recip_sq_exp_x - 1.0) / (1.0 + recip_sq_exp_x)
				| x>= -23.0
					= 2.0 / (1.0 + exp (-2.0*x)) - 1.0
					= -1.0
	asinh :: !Double -> Double
    asinh x
	    | (abs x)<=2.0E-5
			= x-x*x*x/6.0
 		   	= log (x + sqrt (x*x + 1.0))
	acosh :: !Double -> Double
    acosh x
    	| x<=1.000005 && x>=1.0
			# xd = x-1.0
			  z=sqrt (2.0*xd)
			= z-z*xd*(0.083333333333333333333/*1.0/12.0*/-xd*0.01875/*3.0/160.0*/)    		
		   	= log (x + sqrt (x*x - 1.0))
	atanh :: !Double -> Double
	atanh x
	    | (abs x)<=4.0E-6
	    	= x+x*x*x/3.0
			= 0.5 * log ((1.0 + x)/(1.0 - x))
	(**) :: !Double -> !Double -> Double
	a ** b
		= `code inline {
			powR
		}
	logBase :: !Double -> !Double -> Double
	logBase a b = log b / log a

instance Floating Float where
	sqrt :: !Float -> Float
	sqrt a
		= `code inline {
			sqrtRs
		}
	log :: !Float -> Float
	log a
		= `code inline {
			RstoR
			lnR
			RtoRs
		}
	exp :: !Float -> Float
	exp a
		= `code inline {
			RstoR
			expR
			RtoRs
		}
	sin :: !Float -> Float
	sin a
		= `code inline {
			RstoR
			sinR
			RtoRs
		}
	cos :: !Float -> Float
	cos a
		= `code inline {
			RstoR
			cosR
			RtoRs
		}
	tan :: !Float -> Float
	tan a
		= `code inline {
			RstoR
			tanR
			RtoRs
		}
	atan :: !Float -> Float
	atan a
		= `code inline {
			RstoR
			atanR
			RtoRs
		}
	asin :: !Float -> Float
	asin a
		= `code inline {
			RstoR
			asinR
			RtoRs
		}
	acos :: !Float -> Float
	acos a
		= `code inline {
			RstoR
			acosR
			RtoRs
		}
	pi :: Float
	pi
		= `code inline {
			pushRs 3.14159265
		}
	sinh :: !Float -> Float
	sinh x
		| (abs x)<=3.0E-6
			= x+x*x*x/6.0
			# exp_x = exp x
			  exp_xd = exp_x - 1.0
			= 0.5 * (exp_xd + exp_xd / exp_x)
	cosh :: !Float -> Float
	cosh x
		# exp_x = exp x
		= 0.5*exp_x + 0.5/exp_x
	tanh :: !Float -> Float
	tanh x
		| x>=0.0
			| x<=1.0
				| x<=3.0E-6
					= x-x*x*x/3.0
					# recip_sq_exp_x = exp (-2.0*x)
					= (1.0 - recip_sq_exp_x) / (1.0 + recip_sq_exp_x)
				| x<=23.0
					= 1.0 - 2.0 / (1.0 + exp (2.0*x))
					= 1.0
			| x>= -1.0
				| x>= -3.0E-6
					= x-x*x*x/3.0
					# recip_sq_exp_x = exp (2.0*x)
					= (recip_sq_exp_x - 1.0) / (1.0 + recip_sq_exp_x)
				| x>= -23.0
					= 2.0 / (1.0 + exp (-2.0*x)) - 1.0
					= -1.0
	asinh :: !Float -> Float
    asinh x
	    | (abs x)<=2.0E-5
			= x-x*x*x/6.0
 		   	= log (x + sqrt (x*x + 1.0))
	acosh :: !Float -> Float
    acosh x
    	| x<=1.000005 && x>=1.0
			# xd = x-1.0
			  z=sqrt (2.0*xd)
			= z-z*xd*(0.083333333333333333333/*1.0/12.0*/-xd*0.01875/*3.0/160.0*/)    		
		   	= log (x + sqrt (x*x - 1.0))
	atanh :: !Float -> Float
	atanh x
	    | (abs x)<=4.0E-6
	    	= x+x*x*x/3.0
			= 0.5 * log ((1.0 + x)/(1.0 - x))
	(**) :: !Float -> !Float -> Float
	a ** b
		= `code inline {
			push_b 1
			RstoR
			push_b 2
			RstoR
			update_b 3 5
			update_b 2 4
			update_b 1 3
			update_b 0 2
			pop_b 2
			powR
			RtoRs
		}
	logBase :: !Float -> !Float -> Float
	logBase a b = log b / log a

instance RealFrac Double where
	round :: (Integral b) => !Double -> b
	round r = fromInteger (round_real_to_integer r)

	truncate :: (Integral b) => !Double -> b
	truncate r = fromInteger (truncate_real_to_integer r)

	floor :: (Integral b) => !Double -> b
	floor r = fromInteger (floor_real_to_integer r)

	ceiling :: (Integral b) => !Double -> b
	ceiling r = fromInteger (ceiling_real_to_integer r)

	properFraction :: (Integral b) => !Double -> (b,!Double)
	properFraction r
		= let (i,f) = PreludeFloat.proper_integer_fraction_real r in (fromInteger i,f)

round`double_to_int :: !Double -> Int
round`double_to_int r = `code inline {
	 RtoI
}

truncate`double_to_int :: !Double -> Int
truncate`double_to_int r = `code inline {
	truncateR
}

floor`double_to_int :: !Double -> Int
floor`double_to_int r = `code inline {
	entierR
}

ceiling`double_to_int :: !Double -> Int
ceiling`double_to_int r = `code inline {
	ceilingR
}

instance RealFrac Float where
	round :: (Integral b) => !Float -> b
	round f = fromInteger (round_real_to_integer (toReal f))

	truncate :: (Integral b) => !Float -> b
	truncate f = fromInteger (truncate_real_to_integer (toReal f))

	floor :: (Integral b) => !Float -> b
	floor f = fromInteger (floor_real_to_integer (toReal f))

	ceiling :: (Integral b) => !Float -> b
	ceiling f = fromInteger (ceiling_real_to_integer (toReal f))

	properFraction :: (Integral b) => !Float -> (b,!Float)
	properFraction f
		= let (i,fr) = PreludeFloat.proper_integer_fraction_real (toReal f) in (fromInteger i,toFloat fr)

round_float_to_int :: !Float -> Int
round_float_to_int r = `code inline {
	 RstoI
}

truncate_float_to_int :: !Float -> Int
truncate_float_to_int r = `code inline {
	RstoR
	truncateR
}

floor_float_to_int :: !Float -> Int
floor_float_to_int r = `code inline {
	RstoR
	entierR
}

ceiling_float_to_int :: !Float -> Int
ceiling_float_to_int r = `code inline {
	RstoR
	ceilingR
}

instance Enum Double where
	toEnum :: !Int -> Double
	toEnum i = `code inline {
				ItoR
				}

	fromEnum :: !Double -> Int
	fromEnum c = `code inline {
				RtoI
				}
	succ :: !Double -> Double
	succ r = `code inline {
		pushR 1.0
		addR
	}

	pred :: !Double -> Double
	pred r = `code inline {
		pushR -1.0
		addR
	}

	enumFrom :: (Double -> [Double])
	enumFrom = enumFrom`Double
	enumFromThen :: (Double -> Double -> [Double])
	enumFromThen = enumFromThen`Double
	enumFromTo :: (Double -> Double -> [Double])
	enumFromTo = enumFromTo`Double
	enumFromThenTo :: (Double -> Double -> Double -> [Double])
	enumFromThenTo = enumFromThenTo`Double

instance Enum Float where
	toEnum :: !Int -> Float
	toEnum i = `code inline {
				ItoRs
				}

	fromEnum :: !Float -> Int
	fromEnum c = `code inline {
				RstoI
				}
	succ :: !Float -> Float
	succ r = `code inline {
		pushRs 1.0
		addRs
	}

	pred :: !Float -> Float
	pred r = `code inline {
		pushRs -1.0
		addRs
	}

	enumFrom :: (Float -> [Float])
	enumFrom = enumFrom`Float
	enumFromThen :: (Float -> Float -> [Float])
	enumFromThen = enumFromThen`Float
	enumFromTo :: (Float -> Float -> [Float])
	enumFromTo = enumFromTo`Float
	enumFromThenTo :: (Float -> Float -> Float -> [Float])
	enumFromThenTo = enumFromThenTo`Float
