implementation module PreludeInlineRealToFrac where

realToFrac :: (Real a, Fractional b) => a -> b
realToFrac r = fromRational (toRational r)

realToFrac`Double_Double :: !Double -> Double
realToFrac`Double_Double r = `code inline {
	pop_b 0
}

realToFrac`Double_Float :: !Double -> Float
realToFrac`Double_Float r = `code inline {
	pop_b 0
}

realToFrac`Float_Float :: !Float -> Float
realToFrac`Float_Float r = `code inline {
	pop_b 0
}

realToFrac`Float_Double :: !Float -> Double
realToFrac`Float_Double r = `code inline {
	pop_b 0
}

realToFrac`Int_Double :: !Int -> Double
realToFrac`Int_Double i = `code inline {
	ItoR
}

realToFrac`Int_Float :: !Int -> Float
realToFrac`Int_Float i = `code inline {
	ItoR
}

realToFrac`Integer_Double :: !Integer -> Double
realToFrac`Integer_Double {integer_s,integer_a}
	| size integer_a==0
		= realToFrac`Int_Double integer_s;
		= integer_a_to_double integer_s integer_a;

realToFrac`Integer_Float :: !Integer -> Float
realToFrac`Integer_Float {integer_s,integer_a}
	| size integer_a==0
		= realToFrac`Int_Float integer_s;
		= `Float (integer_a_to_double integer_s integer_a);
