module System.Environment (getEnv) where

import PreludeInternal (char_list_to_zstring)
import PreludeInternalIOError

import StdMisc (abort)

getEnv :: String -> IO String
getEnv var_name = IO (getEnvW var_name)

getEnvW :: !String -> !*World -> (!String,!*World)
getEnvW var_name w
	# zc_var_name = char_list_to_zstring var_name
	  a = createArray 64 '\0'
	  r = GetEnvironmentVariable zc_var_name a 64
	| r>0
		| r<64
			= (begin_string_to_char_list r a,w)
			# a = createArray r '\0'
			  r = GetEnvironmentVariable zc_var_name a r
			| r>=0
				= (begin_string_to_char_list r a,w)
				= abort `"GetEnv"
	| r==0
		| GetLastError/=ERROR_ENVVAR_NOT_FOUND
			= ("",w)
			# (IO io) = ioError DoesNotExistError
			= io w
		= abort `"GetEnv"

begin_string_to_char_list :: !Int -> !{#Char} -> [Char]
begin_string_to_char_list n s
	= begin_string_to_char_list 0 n s
  where
	begin_string_to_char_list :: !Int -> !Int -> !{#Char} -> [Char]
	begin_string_to_char_list i n s
		| i<n
			#! c=s~[i]
			= c:begin_string_to_char_list (i+1) n s
			= []	

ERROR_ENVVAR_NOT_FOUND:==203

GetEnvironmentVariable :: !{#Char} -> !{#Char} -> !Int -> Int
GetEnvironmentVariable name buffer buffer_size = `code {
	ccall GetEnvironmentVariableA@12 "PssI:I"
}

GetLastError :: Int
GetLastError = `code {
	ccall GetLastError@0 "P:I"
}
