implementation module StdGeneric

import StdInt, StdMisc, StdClass

generic bimap a b :: Bimap .a .b

bimap_id :: !.a -> .a
bimap_id x = x
/*
bimap_id :: .a -> .a
bimap_id _ = code {
	jmp_eval
}
*/

is_id :: !(.a->.b) -> Bool
is_id f = code inline
{
	eq_desc e_StdGeneric_dbimap_id 0 0
|	eq_desc did.11 0 0
	pop_a 1
};

is_id2 :: !u:(.a->.b) -> (!Bool,!u:(.a->.b))
is_id2 f = code inline
{
	eq_desc e_StdGeneric_dbimap_id 0 0
|	eq_desc did.11 0 0
};

cast :: !.a -> .b
cast f = code inline
{
	pop_a 0
}

bimapId :: Bimap .a .a
bimapId
	= { map_to = bimap_id, map_from = bimap_id }

(o) infixr  9 :: u:(.a -> .b) v:(.c -> .a) -> w:(.c -> .b), [w <= u,w <= v]
(o) f g
	# (f_is_id,f)= is_id2 f
	| f_is_id
		# (g_is_id,g) = is_id2 g
		| g_is_id
			= cast
			= cast g
/*		# (g_is_id,g) = is_id2 g
		| g_is_id
			= cast f
*/
		= \x-> f (g x)

//(o) f g :== \x-> f (g x)

bimap{|c|} = { map_to = bimap_id, map_from = bimap_id }

bimap{|PAIR|} bx by = { map_to= map_to, map_from=map_from }
where
	map_to (PAIR x y) 	= PAIR (bx.map_to x) (by.map_to y)
	map_from (PAIR x y) 	= PAIR (bx.map_from x) (by.map_from y)

bimap{|EITHER|} bl br = { map_to= map_to, map_from=map_from }
where	
	map_to (LEFT x) 	= LEFT (bl.map_to x)
	map_to (RIGHT x)	= RIGHT (br.map_to x)
	map_from (LEFT x) 	= LEFT (bl.map_from x)
	map_from (RIGHT x) 	= RIGHT (br.map_from x)

bimap{|(->)|} barg bres = { map_to = map_to, map_from = map_from }
where
	map_to f
		# res_map_to=bres.map_to
		# arg_map_from=barg.map_from
		| is_id res_map_to
			| is_id arg_map_from
				= cast f
				= \x -> (cast f) (arg_map_from x)
			| is_id arg_map_from
				= \x -> (res_map_to (f (cast x)))
				= res_map_to o (f o arg_map_from)
	map_from f
		# res_map_from=bres.map_from
		# arg_map_to=barg.map_to
		| is_id res_map_from
			| is_id arg_map_to
			 	= cast f
			 	= \x -> (cast f) (arg_map_to x)
			| is_id arg_map_to
			 	= \x -> res_map_from (f (cast x))
			 	= res_map_from o (f o arg_map_to)

//	map_to f		= \x -> bres.map_to (f (barg.map_from x)) 
//	map_from f 		= \x -> bres.map_from (f (barg.map_to x)) 
/*
	map_to f
		= \x -> map_to2 f x
	map_to2 f x
		#! barg_map_from = barg.map_from
		# from_x = barg_map_from x
		#! f_from_x = f from_x
		= bres.map_to f_from_x
	map_from f
		= \x -> map_from2 f x
	map_from2 f x
		#! barg_map_to = barg.map_to
		# to_x = barg_map_to x
		#! f_to_x = f to_x
		= bres.map_from f_to_x 
*/

//	map_to f = bres.map_to o (f o barg.map_from)
//	map_from f = bres.map_from o (f o barg.map_to)

bimap{|CONS|} barg = { map_to= map_to, map_from=map_from }
where
	map_to   (CONS x) = CONS (barg.map_to x)
	map_from (CONS x) = CONS (barg.map_from x)

bimap{|FIELD|} barg = { map_to= map_to, map_from=map_from }
where
	map_to   (FIELD x) = FIELD (barg.map_to x)
	map_from (FIELD x) = FIELD (barg.map_from x)

bimap{|OBJECT|} barg = { map_to= map_to, map_from=map_from }
where
	map_to   (OBJECT x) = OBJECT (barg.map_to x)
	map_from (OBJECT x) = OBJECT (barg.map_from x)

bimap{|Bimap|} x y = {map_to = map_to, map_from = map_from}
where
	map_to 	{map_to, map_from} = 
//		{ map_to 	= \ v -> y.map_to (map_to (x.map_from v))
//		, map_from 	= \ v -> x.map_to (map_from (y.map_from v))
		{ map_to 	= y.map_to o map_to o x.map_from
		, map_from 	= x.map_to o map_from o y.map_from
		}
	map_from {map_to, map_from} = 
//		{ map_to 	= \v -> y.map_from (map_to (x.map_to v))
//		, map_from 	= \v -> x.map_from (map_from (y.map_to v))
		{ map_to 	= y.map_from o map_to o x.map_to
		, map_from 	= x.map_from o map_from o y.map_to
		}

getConsPath :: !GenericConsDescriptor -> [ConsPos]
getConsPath {gcd_index, gcd_type_def={gtd_num_conses}}
	= doit gcd_index gtd_num_conses
where
	doit i n
		| n == 0 	
			= abort "getConsPath: zero conses\n"
		| i >= n	
			= abort "getConsPath: cons index >= number of conses"
		| n == 1
			= []
		| i < (n/2)
			= [ ConsLeft : doit i (n/2) ]
		| otherwise
			= [ ConsRight : doit (i - (n/2)) (n - (n/2)) ]
			  	 							 	